- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ipopt::TAUCSSolverInterface Class Reference

Interface to the linear solver TAUCS, derived from SparseSymLinearSolverInterface. More...

`#include <IpTAUCSSolverInterface.hpp>`

Inheritance diagram for Ipopt::TAUCSSolverInterface:

[legend]
Collaboration diagram for Ipopt::TAUCSSolverInterface:

[legend]
List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
Constructor/Destructor
| TAUCSSolverInterface ()
| Constructor.
virtual | ~TAUCSSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *ia, const Index *ja)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements are to be stored.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *ia, const Index *ja, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
## Private Types
| TAUCS_FACTORTYPE_NONE
| TAUCS_FACTORTYPE_LLT_SUPERNODAL
| TAUCS_FACTORTYPE_LLT_CCS
| TAUCS_FACTORTYPE_IND
enum | TAUCS_Matrix_type { TAUCS_FACTORTYPE_NONE, TAUCS_FACTORTYPE_LLT_SUPERNODAL, TAUCS_FACTORTYPE_LLT_CCS, TAUCS_FACTORTYPE_IND }
| Enum to define different types of factorizations that TAUCS can do. More...
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| TAUCSSolverInterface (const TAUCSSolverInterface &)
| Copy Constructor.
void | operator= (const TAUCSSolverInterface &)
| Overloaded Equals Operator.
Auxilliary methods
ESymSolverStatus | SymbolicFactorization (const Index *ia, const Index *ja)
| TAUCS to do the analysis phase.
ESymSolverStatus | Factorization (const Index *ia, const Index *ja, bool check_NegEVals, Index numberOfNegEVals)
| Call TAUCS to factorize the Matrix.
ESymSolverStatus | Solve (const Index *ia, const Index *ja, Index nrhs, double *rhs_vals)
| Call TAUCS to do the Solve.
int | element_size (int flags)
| return size of matrix entry type
void | taucs_factor_delete_L (taucs_factorization *F)
| Delete TAUCS' factorization structure.
void | taucs_delete (taucs_factorization *F, taucs_ccs_matrix *A)
| Delete TAUCS' factorization and matrix.
## Private Attributes
Information about the matrix
Index | n_
| Number of rows and columns of the matrix.
Index | nz_
| Number of nonzeros of the matrix in triplet representation.
double * | a_
| Array for storing the values of the matrix.
bool | multi_frontal_
| Flag indicatining whether to use multifrontal or IC indefinite LL factorization.
taucs_factorization * | taucs_factor_
| Structure storing information about the factorization.
taucs_ccs_matrix * | A_
| Storing the matrix in TAUCS format.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
bool | initialized_
| Flag indicating if internal data is initialized.
## Classes
struct | taucs_factorization
| Structure to store information about the factorization. More...

## Detailed Description

Interface to the linear solver TAUCS, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 34 of file IpTAUCSSolverInterface.hpp.

## Member Enumeration Documentation

enum Ipopt::TAUCSSolverInterface::TAUCS_Matrix_type`[private]`

Enum to define different types of factorizations that TAUCS can do.

Enumerator:

  TAUCS_FACTORTYPE_NONE |
  TAUCS_FACTORTYPE_LLT_SUPERNODAL |
  TAUCS_FACTORTYPE_LLT_CCS |
  TAUCS_FACTORTYPE_IND |

Definition at line 38 of file IpTAUCSSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::TAUCSSolverInterface::TAUCSSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::TAUCSSolverInterface::~TAUCSSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::TAUCSSolverInterface::TAUCSSolverInterface | ( | const TAUCSSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::TAUCSSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::TAUCSSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::TAUCSSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements are to be stored.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::TAUCSSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::TAUCSSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::TAUCSSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::TAUCSSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 107 of file IpTAUCSSolverInterface.hpp.

EMatrixFormat Ipopt::TAUCSSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 114 of file IpTAUCSSolverInterface.hpp.

References Ipopt::SparseSymLinearSolverInterface::CSR_Format_0_Offset.

void Ipopt::TAUCSSolverInterface::operator= | ( | const TAUCSSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

ESymSolverStatus Ipopt::TAUCSSolverInterface::SymbolicFactorization | ( | const Index * | ia,
|  | const Index * | ja |
| ) |  |  | `[private]`

TAUCS to do the analysis phase.

ESymSolverStatus Ipopt::TAUCSSolverInterface::Factorization | ( | const Index * | ia,
|  | const Index * | ja,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call TAUCS to factorize the Matrix.

ESymSolverStatus Ipopt::TAUCSSolverInterface::Solve | ( | const Index * | ia,
|  | const Index * | ja,
|  | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call TAUCS to do the Solve.

int Ipopt::TAUCSSolverInterface::element_size | ( | int | flags | ) | `[inline, private]`

return size of matrix entry type

Definition at line 187 of file IpTAUCSSolverInterface.hpp.

void Ipopt::TAUCSSolverInterface::taucs_factor_delete_L | ( | taucs_factorization * | F | ) | `[private]`

Delete TAUCS' factorization structure.

void Ipopt::TAUCSSolverInterface::taucs_delete | ( | taucs_factorization * | F,
|  | taucs_ccs_matrix * | A |
| ) |  |  | `[private]`

Delete TAUCS' factorization and matrix.

## Member Data Documentation

Index Ipopt::TAUCSSolverInterface::n_`[private]`

Number of rows and columns of the matrix.

Definition at line 139 of file IpTAUCSSolverInterface.hpp.

Index Ipopt::TAUCSSolverInterface::nz_`[private]`

Number of nonzeros of the matrix in triplet representation.

Definition at line 142 of file IpTAUCSSolverInterface.hpp.

double* Ipopt::TAUCSSolverInterface::a_`[private]`

Array for storing the values of the matrix.

Definition at line 145 of file IpTAUCSSolverInterface.hpp.

bool Ipopt::TAUCSSolverInterface::multi_frontal_`[private]`

Flag indicatining whether to use multifrontal or IC indefinite LL factorization.

Definition at line 149 of file IpTAUCSSolverInterface.hpp.

taucs_factorization* Ipopt::TAUCSSolverInterface::taucs_factor_`[private]`

Structure storing information about the factorization.

Definition at line 152 of file IpTAUCSSolverInterface.hpp.

taucs_ccs_matrix* Ipopt::TAUCSSolverInterface::A_`[private]`

Storing the matrix in TAUCS format.

Definition at line 155 of file IpTAUCSSolverInterface.hpp.

Index Ipopt::TAUCSSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 161 of file IpTAUCSSolverInterface.hpp.

bool Ipopt::TAUCSSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 165 of file IpTAUCSSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Ipopt-3.2.1/Ipopt/src/Algorithm/LinearSolvers/IpTAUCSSolverInterface.hpp